# vim: ts=4
###
#
# Listen is the legal property of mehdi abaakouk <theli48@gmail.com>
# Copyright (c) 2006 Mehdi Abaakouk
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###



import gtk
import gobject
from helper import helper   

class MMKeys:
    def __init__(self):
        self.application = 'Listen'
        self.use = self.__use_gnome() or self.__use_mmkeys()
    
    def __use_gnome(self):
        def on_gnome_mmkey(app, key):
            if app == self.application:
                if key == "Play":
                    helper.control("play")
                if key == "PlayPause":
                    helper.control("play")
                if key == "Stop":
                    helper.control("stop")
                if key == "Next":
                    helper.control("next")
                if key == "Previous":
                    helper.control("previous")
        
        try:
        	import dbus
        	bus = dbus.SessionBus()
        	obj = bus.get_object('org.gnome.SettingsDaemon', '/org/gnome/SettingsDaemon/MediaKeys')
        	self.__gnome = dbus.Interface(obj, 'org.gnome.SettingsDaemon.MediaKeys')
        	self.__gnome.GrabMediaPlayerKeys(self.application, 0)
        	self.__gnome.connect_to_signal("MediaPlayerKeyPressed", on_gnome_mmkey)
        except:
        	return None
        
        return 'gnome'
    
    def __use_mmkeys(self):
        try:import mmkeys
        except:
        	return None
        
        self.__keys = mmkeys.MmKeys()
        self.__keys.connect("mm_prev", self.mm_previous)
        self.__keys.connect("mm_next", self.mm_next)
        self.__keys.connect('mm_stop', self.mm_play)
        self.__keys.connect("mm_playpause", self.mm_play)
        
        return 'mmkeys'
        
    def __del__(self):
    	if self.use == 'gnome':
    		self.__gnome.ReleaseMediaPlayerKeys(self.application)
        
    def mm_play(self,a,b):
    	helper.control("play")
    	
    def mm_next(self,a,b):
    	helper.control("next")
    	
    def mm_previous(self,a,b):
    	helper.control("previous")

mmkey = MMKeys()    
